#include <stdio.h>
#include <stdlib.h>

#define MAX_N 400

FILE *inp, *outp;
int N, input_type, R[MAX_N], compare_count;
int min_possibility[MAX_N], max_possibility[MAX_N];
int min_possible_count, max_possible_count;
int max_fresh;

static void correct() {
	fprintf(stderr, "translate:success\n");
	printf("1.0\n");
	exit(0);
}

static void wrong(int) {
	fprintf(stderr, "translate:wrong\n");
	printf("0.0\n");
	exit(0);
}

int compare_internal(int X, int Y) {
	if (R[X] > R[Y]) return 1;
	if (R[X] < R[Y]) return -1;
	if (X > Y) return 1;
	if (X < Y) return -1;
	return 0;
}

int Compare(int X, int Y) {
	int c;
	if (X < 0 || N <= X || Y < 0 || N <= Y || X == Y) {
		fprintf(inp, "0\n");
		wrong(1);
	}
	++compare_count;
	if (compare_count > 600) {
		fprintf(inp, "0\n");
		wrong(2);
	}
	c = compare_internal(X, Y);
	if (input_type == 2) {
		int count1 = min_possibility[X] + max_possibility[Y];
		int count2 = min_possibility[Y] + max_possibility[X];
		if (c > 0 && count1 == 2 && count2 < 2) {
			R[Y] = ++max_fresh;
			c = compare_internal(X, Y);
		}
		if (c < 0 && count1 < 2 && count2 == 2) {
			R[X] = ++max_fresh;
			c = compare_internal(X, Y);
		}
	}
	if (c > 0) {
		min_possible_count -= min_possibility[X];
		max_possible_count -= max_possibility[Y];
		min_possibility[X] = 0;
		max_possibility[Y] = 0;
	}
	if (c < 0) {
		min_possible_count -= min_possibility[Y];
		max_possible_count -= max_possibility[X];
		min_possibility[Y] = 0;
		max_possibility[X] = 0;
	}
	return c;
}

void Answer(int X, int Y) {
	if (X < 0 || N <= X || Y < 0 || N <= Y) {
		wrong(3);
	}
	if (min_possible_count > 1 || max_possible_count > 1) {
		wrong(4);
	}
	if (min_possibility[X] && max_possibility[Y]) {
		correct();
	}
	wrong(4);
}

int main(int argc, char **argv) {
	int i;
	if (argc != 3) {
		fprintf(stderr, "usage: %s <in> <out> < input > output\n", argv[0]);
		exit(1);
	}
	inp = fopen(argv[1], "w");
	if (!inp) {
		fprintf(stderr, "can't open %s\n", argv[1]);
		exit(1);
	}
	outp = fopen(argv[2], "r");
	if (!outp) {
		fprintf(stderr, "can't open %s\n", argv[2]);
		exit(1);
	}

	if (scanf("%d%d", &N, &input_type) < 2) {
		fprintf(stderr, "error: cannot read N and input_type.\n");
		exit(1);
	}
	if (N <= 0 || MAX_N < N) {
		fprintf(stderr, "error: N is out of bounds.\n");
		exit(1);
	}
	if (input_type == 1 || input_type == 2) {
		for (i = 0; i < N; ++i) {
			if (scanf("%d", &R[i]) < 1) {
				fprintf(stderr, "error: cannot read R[%d].\n", i);
			}
		}
		max_possible_count = N;
		min_possible_count = N;
		max_fresh = R[0];
		for (i = 0; i < N; ++i) {
			min_possibility[i] = 1;
			max_possibility[i] = 1;
			if (max_fresh < R[i]) {
				max_fresh = R[i];
			}
		}
	} else {
		fprintf(stderr, "error: input_type is not 1 nor 2.\n");
		exit(1);
	}
	compare_count = 0;

	fprintf(inp, "%d\n", N);
	fflush(inp);
	while (true) {
		int q, X, Y;
		if (fscanf(outp, "%d%d%d", &q, &X, &Y) < 3) {
			wrong(6);
		}
		if (q == 0) {
			fprintf(inp, "%d\n", Compare(X, Y));
			fflush(inp);
		} else {
			Answer(X, Y);
		}
	}
	return 0;
}
